/* encoder.c */

/* $Id nope */

/*
uudecode and uuencode are easily implemented under MSDOS as well.  Here
are the sources for Microsoft C v3.0, but if you have another kind of C
compiler, there should be perhaps only 1 change -- the output file of
uudecode and the input file of uuencode must be in binary format.
(ie.  binary files, like .EXE files may have byte patterns that are the
same as ^Z, which signals end-of-file in non-binary (text) mode).

Don Kneller
UUCP:   ...ucbvax!ucsfcgl!kneller
ARPA:   kneller@ucsf-cgl.ARPA
BITNET: kneller@ucsfcgl.BITNET

patched up for BC++ 3.1 by Alan Eldridge 10/12/92
(UUCP: alane@wozzle.linet.org, FIDO: 1:272/38.473)

rerecode, sections and shugar (x) 1998-99 by _ext

*/

#ifdef __BORLANDC__
#define MSDOS
#include <alloc.h>
#endif

#ifndef lint
#ifndef MSDOS
static char sccsid[] = "@(#)uuencode.c  5.1 (Berkeley) 7/2/83";
#endif
#endif

/*
* uuencode [input] output
*
* Encode a file so it can be mailed to a remote system.
*/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

#ifndef __BORLANDC__
#ifndef __GNUC__
#error unknown compiler
#else
#define far
#endif
#else
//#define malloc farmalloc
//#define realloc farrealloc
//#define free farfree
//#define calloc farcalloc
#endif

/* ENC is the basic 1 character encoding function to make a char printing */

#define ENC(c) (((c) & 077) + ' ')

int fr(FILE * fd, char *buf, int cnt);

unsigned int rcrc[100];
unsigned int rsize[100];

const char *ver = "1.2"; /* rev */

#define IBUF_SIZ 0x1000
char **raw = NULL;
int lines = 0, curSection = 1;

/*
* output one group of 3 bytes, pointed at by p, on file f.
*/

void outdec(char *p, char **bufout) {
    register int c1, c2, c3, c4;

    c1 = *p >> 2;
    c2 = ((p[0] << 4) & 060) | ((p[1] >> 4) & 017);
    c3 = ((p[1] << 2) & 074) | ((p[2] >> 6) & 03);
    c4 = p[2] & 077;
    **bufout = ENC(c1); 
    if(**bufout==' ') **bufout='`';
    (*bufout)++;

    **bufout = ENC(c2);
    if(**bufout==' ') **bufout='`';
    (*bufout)++;

    **bufout = ENC(c3);
    if(**bufout==' ') **bufout='`';
    (*bufout)++;

    **bufout = ENC(c4);
    if(**bufout==' ') **bufout='`';
    (*bufout)++;
}

unsigned int mask=0x8000;

/*
* fairly stupid, but fairly portable =) (BE/LE not aware)
*/

unsigned int crcLine(unsigned int crc, unsigned char h) {
    unsigned int rez=crc;
    int cf = 0;

    if (crc & 1) {
        cf = 1;
    }

    rez = rez >> 1;
    if (cf)
        rez |= mask;

    rez += h;

    return rez;
}


void makeBar(char *bar, int cur, int total) {
    int i, up;

    up = 100 * cur / total;

    #ifdef UNIX
    memset(&bar, 'X', up / 3);
    #else
    memset(&bar, 0xfe, up / 3);
    #endif

    bar[(up / 3) + ((100 - up) / 3)] = 0;
}


static char *replicate(int len, char ch) {
    static char tmp[256];

    memset(tmp, ch, len);
    tmp[len] = 0;

    return tmp;
}


/*
* copy from in to out, encoding as you go along.
*/

static void encode(FILE * in, int mode, char *fileName) {
    char buf[80], barsik[80];
    int i, n, curLine = 0, up;
    char *bufout, *ptr, *fu;
    unsigned int crc = 0, fcrc=0;

    bufout = calloc(1, 82);
    assert(bufout);

    raw = malloc(sizeof(char *));

    assert(raw);

    raw[curSection - 1] = calloc(1, (62 + 2) * lines);
    assert(raw[curSection - 1]);

    memset(&buf, 0, sizeof(buf));
    sprintf(buf, "begin %o %s\n", mode, fileName);

    rsize[curSection - 1] = strlen(buf);
    for (i = 0; i < strlen(buf); i++) {
        crc = crcLine(crc, buf[i]);
    }

    for (;;) {

        if (curLine > lines) {
            curLine = 0;

            rcrc[curSection - 1] = crc;
            crc = 0u;

            curSection++;
            raw = realloc(raw, curSection * sizeof(char *));

            assert(raw);

            raw[curSection - 1] = calloc(1, (62 + 1) * lines);
            assert(raw[curSection - 1]);

            raw[curSection - 1][0] = 0;
            rsize[curSection - 1] = 0;

        }

/* 1 (up to) 45 character line */

        memset(&buf, 0, sizeof(buf));
        n = fr(in, buf, 45);
        ptr = bufout;
        bufout[0] = ENC(n);
        bufout++;

        for (i = 0; i < n; i += 3)
            outdec(&buf[i], &bufout);

        bufout = ptr;

        if (strlen(bufout) <= 1)
            break;

        for(i=0; i<n; i++) fcrc=crcLine(fcrc, buf[i]);

        while (*bufout) {
            crc = crcLine(crc, (*bufout));
            bufout++;
        }
        crc = crcLine(crc, 0x0a);
        bufout = ptr;

        rsize[curSection - 1] += (strlen(bufout) + 1);

        if (strlen(bufout) > 1)
            strcat(raw[curSection - 1], bufout);

        if (n > 0)
            strcat(raw[curSection - 1], "\n");

        curLine++;

        if (n <= 0) {
            rcrc[curSection - 1] = crc;
            break;
        }

        memset(bufout, 0, 82);
    }

    strcat(raw[curSection - 1], "`\n");
    crc = crcLine(crc, '`');
    crc = crcLine(crc, 0x0a);
    rcrc[curSection - 1] = crc;
    rsize[curSection - 1] += 2;

    fu = strdup(fileName);
    for (i = 0; i < strlen(fileName); i++) {
        fu[i] = toupper(fileName[i]);
    }

    for (i = 0; i < curSection; i++) {
        up = 100 * (i + 1) / curSection;

        #ifdef UNIX
        memset(&barsik, 'x', sizeof(barsik));
        memset(&barsik, 'X', up / 3);
        #else
        memset(&barsik, 0xf9, sizeof(barsik));
        memset(&barsik, 0xfe, up / 3);
        #endif

        barsik[(up / 3) + ((100 - up) / 3)] = 0;

        printf("%s %s [%s] %d%%\n\n", replicate((58 - strlen(barsik) - 2 - strlen(fileName) - 5) / 2, ' '),
        fu, barsik, (int) up);

        printf("section %d of %d of file %s encoder %s by _ext\n",
        i + 1, curSection, fileName, ver);

        if (i == 0) {
            printf("begin %o %s\n", mode, fileName);
        }

        printf("%s", raw[i]);

        if (i + 1 == curSection) {
            crc = crcLine(crc, 'e');
            crc = crcLine(crc, 'n');
            crc = crcLine(crc, 'd');
            crc = crcLine(crc, 0x0a);
            rcrc[curSection - 1] = crc;
            rsize[curSection - 1] += (strlen("end") + 1);
            printf("end\n");
        }

        printf("sum -r/size %u/%u section ", rcrc[i], rsize[i]);
        printf("%s\n", curSection == 1 ? "(from \"begin\" to \"end\")" :
        i == 0 ? "(from \"begin\" to last encoded line)"
        : "(from first to last encoded line)");

        if (i + 1 == curSection) {
            printf("sum -r/size %u/%lu entire input file", fcrc, filelength(fileno(in)));
        }
        puts("");
    }

    fclose(in);
}


/* fr: like read but stdio */

int fr(FILE * fd, char *buf, int cnt) {
    register int c, i;

    for (i = 0; i < cnt; i++) {
        c = getc(fd);
        if (c == EOF)
            return (i);
        buf[i] = (char) c;
    }
    return (cnt);
}

int main(int argc, char *argv[]) {
    FILE *in;
    struct stat sbuf;
    int mode;
    int i = 1;

/* optional 1st argument */

    if (argc > 1) {
        #ifdef MSDOS

        if (argv[i][0] == '-' && argv[i][1] == 'l') {
            lines = atoi((argv[1]) + 2);
            if (lines == 0) {
                fprintf(stderr, "Wrong lines count\n");
                exit(3);
            }
            i++;
        }
        else {
            lines = 110;
        }

/* Use binary mode */
        if ((in = fopen(argv[i], "rb")) == NULL) {
            #else
            if ((in = fopen(argv[i], "r")) == NULL) {
                #endif
                perror(argv[i]);
                exit(1);
            }
        }
        else {
#ifdef MSDOS
            printf("usage: %s [-lXXX] <file> ><outfile>\n", argv[0]);
#else
            printf("usage: %s <file> ><outfile>\n", argv[0]);
#endif
            exit(0);
        }

/* figure out the input file mode */

        fstat(fileno(in), &sbuf);
        mode = sbuf.st_mode & 0777;

        #ifdef MSDOS
        mode = 0644;
        #endif

        encode(in, mode, argv[i]);

        return 0;
    }


/* EOF */
